package de.intevation.gnv.geobackend.base.connectionpool;

import de.intevation.gnv.geobackend.base.connectionpool.exception.ConnectionException;

import java.sql.Connection;

import java.util.Properties;

/**
 * Interfacedefinition for an Generic ConnectionPool
 * @author <a href="mailto:tim.englich@intevation.de">Tim Englich</a>
 */
public interface ConnectionPool {

    /**
     * Delivers the Connection to the Database
     * @param connectionID the ID of the Connection
     * @return the Connection to the Database
     * @throws ConnectionException
     */
    public Connection getConnection(String connectionID) throws ConnectionException;

    /**
     * Returns the Connection to the Pool
     * @param connection the Connection which should be returned to the Pool
     * @throws ConnectionException
     */
    public void closeConnection(Connection connection) throws ConnectionException;

    /**
     * Initializes the ConnectionPool
     * @param properties The Properties which should be used for initializing theConnectionPool
     */
    public void initialize(Properties properties);

}
